Subject: Re: bug#65459: completing-read INITIAL-VALUE unaware of COLLECTION and REQUIRE-MATCH

From: Stefan Monnier <[email-masked]>
Date: Sun, 27 Aug 2023 17:48:10 -0400

> There are two audiences in all this.  Programmers who write libraries
> and users who write functions for their own use.  The thought is that
> if `read-file-name` has capability of minibuffer prefilling, then minibuffer
> prefilling capability should be available for them to use without having
> them convince anybody why they want it to happen.

As I said, as a matter of principle and general design, Emacs goes to
great lengths to make sure users can do even what we *don't* want them
to do (except make our code proprietary).  So of course it is and will
remain possible for users to write code that prefills the minibuffer.

The question is how to make an API that encourages coders to write code in
such a way that the behavior is fairly homogeneous between packages and
such that users can customize the behavior to be the way they like it.

        Stefan